var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import JsonEditor from '../JsonEditor';
import { Input } from 'antd';
export default class NodeJsonEditor extends React.Component {
    static get key() {
        return 'json-editor';
    }
    static get name() {
        return 'Json';
    }
    static filter(node) {
        return true;
    }
    constructor(props) {
        super(props);
        const { schema, uiSchema } = props;
        this.state = {
            schemaJsonString: JSON.stringify(schema, null, 2),
            uiSchemaJsonString: JSON.stringify(schema, null, 2),
            schema,
            uiSchema,
        };
    }
    render() {
        const { node, updateNode } = this.props;
        const { schema, uiSchema } = node;
        const { properties, items, additionalItems } = schema, rschema = __rest(schema, ["properties", "items", "additionalItems"]);
        return (React.createElement("div", null,
            React.createElement(Input, { value: node.name, onChange: (e) => updateNode({ name: e.target.value }) }),
            React.createElement(JsonEditor, { value: rschema, onChange: (schema) => updateNode({ schema }), autosize: true }),
            React.createElement(JsonEditor, { value: uiSchema, onChange: (uiSchema) => updateNode({ uiSchema }), autosize: true })));
    }
}
//# sourceMappingURL=JsonEditor.js.map