import React, { useMemo } from 'react';
import { List, Button } from 'antd';
const FormList = ({ data, onSelect }) => {
    const items = useMemo(() => {
        return data.map(d => (React.createElement(List.Item, { key: d.id, onClick: () => onSelect(d) }, d.name)));
    }, [data]);
    return (React.createElement("div", null,
        React.createElement("div", { style: { position: 'relative', right: 0 } },
            React.createElement(Button, { onClick: () => onSelect(null), type: "primary", icon: "plus" })),
        React.createElement(List, { bordered: true }, items)));
};
export default FormList;
//# sourceMappingURL=formList.js.map