var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import { getWidget, getUiOptions, optionsList, getDefaultRegistry } from './utils';
function BooleanField(props) {
    const { schema, name, uiSchema, idSchema, formData, registry = getDefaultRegistry(), required, disabled, readonly, autofocus, onChange, rawErrors, } = props;
    const { title } = schema;
    const { widgets, formContext } = registry;
    const _a = getUiOptions(uiSchema), { widget = 'checkbox' } = _a, options = __rest(_a, ["widget"]);
    const Widget = getWidget(schema, widget, widgets);
    const enumOptions = optionsList({
        enum: [true, false],
        enumNames: schema.enumNames || ['yes', 'no'],
    });
    return (React.createElement(Widget, { options: Object.assign(Object.assign({}, options), { enumOptions }), schema: schema, id: idSchema && idSchema.$id, onChange: onChange, label: title === undefined ? name : title, value: formData, required: required, disabled: disabled, readonly: readonly, registry: registry, formContext: formContext, autofocus: autofocus, rawErrors: rawErrors }));
}
if (process.env.NODE_ENV !== 'production') {
    BooleanField.propTypes = {
        schema: PropTypes.object.isRequired,
        uiSchema: PropTypes.object,
        idSchema: PropTypes.object,
        onChange: PropTypes.func.isRequired,
        formData: PropTypes.bool,
        required: PropTypes.bool,
        disabled: PropTypes.bool,
        readonly: PropTypes.bool,
        autofocus: PropTypes.bool,
        registry: PropTypes.shape({
            widgets: PropTypes.objectOf(PropTypes.oneOfType([PropTypes.func, PropTypes.object])).isRequired,
            fields: PropTypes.objectOf(PropTypes.func).isRequired,
            definitions: PropTypes.object.isRequired,
            formContext: PropTypes.object.isRequired,
        }),
        rawErrors: PropTypes.arrayOf(PropTypes.string),
    };
}
BooleanField.defaultProps = {
    uiSchema: {},
    disabled: false,
    readonly: false,
    autofocus: false,
};
export default BooleanField;
//# sourceMappingURL=BooleanField.js.map