var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import { getWidget, getUiOptions, isSelect, optionsList, getDefaultRegistry } from './utils';
function StringField(props) {
    const { schema, name, uiSchema, idSchema, formData, required, disabled, readonly, autofocus, onChange, onBlur, onFocus, registry = getDefaultRegistry(), rawErrors, } = props;
    const { title, format } = schema;
    const { widgets, formContext } = registry;
    const enumOptions = isSelect(schema) && optionsList(schema);
    const defaultWidget = format || (enumOptions ? 'select' : 'text');
    const _a = getUiOptions(uiSchema), { widget = defaultWidget, placeholder = '' } = _a, options = __rest(_a, ["widget", "placeholder"]);
    const Widget = getWidget(schema, widget, widgets);
    return (React.createElement(Widget, { options: Object.assign(Object.assign({}, options), { enumOptions }), schema: schema, id: idSchema && idSchema.$id, label: title === undefined ? name : title, value: formData, onChange: onChange, onBlur: onBlur, onFocus: onFocus, required: required, disabled: disabled, readonly: readonly, formContext: formContext, autofocus: autofocus, registry: registry, placeholder: placeholder, rawErrors: rawErrors }));
}
if (process.env.NODE_ENV !== 'production') {
    StringField.propTypes = {
        schema: PropTypes.object.isRequired,
        uiSchema: PropTypes.object.isRequired,
        idSchema: PropTypes.object,
        onChange: PropTypes.func.isRequired,
        onBlur: PropTypes.func,
        onFocus: PropTypes.func,
        formData: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
        registry: PropTypes.shape({
            widgets: PropTypes.objectOf(PropTypes.oneOfType([PropTypes.func, PropTypes.object])).isRequired,
            fields: PropTypes.objectOf(PropTypes.func).isRequired,
            definitions: PropTypes.object.isRequired,
            formContext: PropTypes.object.isRequired,
        }),
        formContext: PropTypes.object.isRequired,
        required: PropTypes.bool,
        disabled: PropTypes.bool,
        readonly: PropTypes.bool,
        autofocus: PropTypes.bool,
        rawErrors: PropTypes.arrayOf(PropTypes.string),
    };
}
StringField.defaultProps = {
    uiSchema: {},
    disabled: false,
    readonly: false,
    autofocus: false,
};
export default StringField;
//# sourceMappingURL=StringField.js.map