"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const store_1 = require("./store");
const react_2 = require("redux-persist/integration/react");
// import './css';
const antd_1 = require("antd");
const Tree_1 = require("./Tree");
const views_1 = require("./views");
const Editor_1 = require("./Editor");
const Toolbar_1 = require("./Toolbar");
const Settings_1 = require("./Settings");
const openFormList_1 = require("./remote/openFormList");
const { Header, Sider, Content } = antd_1.Layout;
const { TabPane } = antd_1.Tabs;
const { dispatch } = store_1.store;
class App extends react_1.Component {
    constructor() {
        super(...arguments);
        this.state = {
            collapsed: false,
            data: this.props.data,
            modal: null,
        };
        this.toggle = () => {
            this.setState({
                collapsed: !this.state.collapsed,
            });
        };
        this.setStore = ({ schema, uiSchema, formData }) => {
            dispatch({
                type: 'TREE_SET_TREE',
                payload: { schema, uiSchema },
            });
            dispatch({
                type: 'FORM_DATA_SET',
                payload: formData,
            });
        };
        this.handleSave = (config) => {
            const { formId, formName } = this.state;
            if (this.state.create) {
                if (this.props.onCreate) {
                    this.props.onCreate(Object.assign({ name: config.schema.title }, config));
                }
            }
            else {
                if (this.props.onSave) {
                    this.props.onSave(Object.assign({ id: formId, name: formName }, config));
                }
            }
        };
        this.handleSelect = (config) => {
            const { id, name, schema = { title: 'ofm' }, uiSchema = {}, formData = {} } = config || {};
            this.setStore({ schema, uiSchema, formData });
            this.setState({ create: !id, formId: id, formName: name });
        };
        this.openModal = () => {
            let m = openFormList_1.default(this.state.data, this.handleSelect);
            this.setState({ modal: m });
        };
    }
    UNSAFE_componentWillReceiveProps(nextProps) {
        if (nextProps.data !== this.props.data) {
            if (nextProps.data !== null && nextProps.data !== undefined && this.state.modal === null) {
                let m = openFormList_1.default(this.state.data, this.handleSelect);
                this.setState({
                    modal: m,
                    data: nextProps.data,
                });
            }
        }
    }
    componentDidUpdate(prevProps) {
        if (prevProps.data !== this.props.data) {
            this.setState({
                data: this.props.data,
            });
            if (this.props.data) {
            }
        }
    }
    render() {
        const { settings } = this.props;
        return (react_1.default.createElement(antd_1.Layout, { style: { transform: 'rotate(0)' } },
            react_1.default.createElement(Sider, { trigger: null, collapsible: true, collapsed: this.state.collapsed, width: settings.leftSiderWidth, style: {
                    background: '#fff',
                    padding: 0,
                    overflow: 'auto',
                    boxShadow: '0 2px 3px 0 rgba(0, 0, 0, 0.2), 0 2px 3px 0 rgba(0, 0, 0, 0.2)',
                    height: '100vh',
                    position: 'fixed',
                    left: 0,
                } },
                react_1.default.createElement(antd_1.Tabs, { defaultActiveKey: "0", size: "small" },
                    react_1.default.createElement(TabPane, { tab: "Editor", style: { padding: '8px' }, key: "0" },
                        react_1.default.createElement(Tree_1.default, null)),
                    react_1.default.createElement(TabPane, { tab: "Settings", style: { padding: '8px' }, key: "1" },
                        react_1.default.createElement(Settings_1.default, null)))),
            react_1.default.createElement(antd_1.Layout, { style: { marginLeft: settings.leftSiderWidth } },
                react_1.default.createElement(Header, { style: { background: '#fff', padding: 0 } },
                    react_1.default.createElement(Toolbar_1.default, { onOpen: () => this.openModal(), onSave: this.handleSave })),
                react_1.default.createElement(Content, { style: { minHeight: 280, padding: '12px 8px', display: 'flex', flexWrap: 'wrap' } },
                    react_1.default.createElement(antd_1.Card, { bordered: false, style: { width: settings.formWidth, margin: '12px 8px', display: 'inline-block', verticalAlign: 'top' } },
                        react_1.default.createElement(views_1.FormView, null)),
                    (settings.subViews || []).map((a) => {
                        const style = { margin: '12px 8px', width: 400, display: 'inline-block', verticalAlign: 'top', maxHeight: '800px', overflowY: 'scroll' };
                        switch (a) {
                            case 'schema':
                                return (react_1.default.createElement(antd_1.Card, { key: "schema", title: "Schema", style: style },
                                    react_1.default.createElement(views_1.SchemaView, null)));
                            case 'uiSchema':
                                return (react_1.default.createElement(antd_1.Card, { key: "uiSchema", title: "Ui Schema", style: style },
                                    react_1.default.createElement(views_1.UiSchemaView, null)));
                            case 'formData':
                                return (react_1.default.createElement(antd_1.Card, { key: "formData", title: "Form Data", style: style },
                                    react_1.default.createElement(views_1.FormDataView, null)));
                            default:
                                return react_1.default.createElement("div", { key: "null" });
                        }
                    }))),
            react_1.default.createElement(Sider, { width: this.props.activeNodeKey ? settings.rightSiderWidth : 0, style: {
                    overflow: 'auto',
                    background: '#fff',
                    boxShadow: '0 2px 3px 0 rgba(0, 0, 0, 0.2), 0 2px 3px 0 rgba(0, 0, 0, 0.2)',
                    // position: 'fixed',
                    height: '100vh',
                } },
                react_1.default.createElement(Editor_1.default, null))));
    }
}
const AppContainer = react_redux_1.connect(({ activeNodeKey, settings }) => ({
    activeNodeKey,
    settings,
}))(App);
exports.default = (_a) => {
    var props = __rest(_a, []);
    return (react_1.default.createElement(react_redux_1.Provider, { store: store_1.store },
        react_1.default.createElement(react_2.PersistGate, { loading: null, persistor: store_1.persistor },
            react_1.default.createElement(AppContainer, Object.assign({}, props)))));
};
//# sourceMappingURL=App.js.map