"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const JsonEditor_1 = require("../JsonEditor");
const antd_1 = require("antd");
class NodeJsonEditor extends react_1.default.Component {
    static get key() {
        return 'json-editor';
    }
    static get name() {
        return 'Json';
    }
    static filter(node) {
        return true;
    }
    constructor(props) {
        super(props);
        const { schema, uiSchema } = props;
        this.state = {
            schemaJsonString: JSON.stringify(schema, null, 2),
            uiSchemaJsonString: JSON.stringify(schema, null, 2),
            schema,
            uiSchema,
        };
    }
    render() {
        const { node, updateNode } = this.props;
        const { schema, uiSchema } = node;
        const { properties, items, additionalItems } = schema, rschema = __rest(schema, ["properties", "items", "additionalItems"]);
        return (react_1.default.createElement("div", null,
            react_1.default.createElement(antd_1.Input, { value: node.name, onChange: (e) => updateNode({ name: e.target.value }) }),
            react_1.default.createElement(JsonEditor_1.default, { value: rschema, onChange: (schema) => updateNode({ schema }), autosize: true }),
            react_1.default.createElement(JsonEditor_1.default, { value: uiSchema, onChange: (uiSchema) => updateNode({ uiSchema }), autosize: true })));
    }
}
exports.default = NodeJsonEditor;
//# sourceMappingURL=JsonEditor.js.map