"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const antd_1 = require("antd");
const JsonEditor_1 = require("./JsonEditor");
const BasicEditor_1 = require("./BasicEditor");
const { getNode } = require('../core');
const { TabPane } = antd_1.Tabs;
const editorList = [BasicEditor_1.default, JsonEditor_1.default];
class Editor extends react_1.default.Component {
    constructor() {
        super(...arguments);
        this.updateUiOptions = (uiOptionsUpdate) => {
            const { uiSchema = {}, key } = this.props.node;
            const uiOptions = uiSchema['ui:options'] || {};
            const newUiOptions = Object.assign(Object.assign({}, uiOptions), uiOptionsUpdate);
            for (const i in newUiOptions) {
                if (newUiOptions[i] !== undefined) {
                    this.props.updateNode(key, { uiSchema: Object.assign(Object.assign({}, uiSchema), { 'ui:options': Object.assign(Object.assign({}, uiOptions), newUiOptions) }) });
                    return;
                }
            }
            this.props.updateNode(key, { uiSchema: Object.assign(Object.assign({}, uiSchema), { 'ui:options': undefined }) });
        };
    }
    render() {
        const { node, updateNode } = this.props;
        if (!(node && node.schema))
            return null;
        const filteredEditors = editorList.filter((a) => a.filter(node));
        return (react_1.default.createElement(antd_1.Tabs, { defaultActiveKey: filteredEditors[0].key, onChange: console.log }, filteredEditors.map((Editor) => (react_1.default.createElement(TabPane, { tab: Editor.name, key: Editor.key },
            react_1.default.createElement("div", { style: { margin: '0px 16px' } },
                react_1.default.createElement(Editor, { key: node.key, node: node, updateNode: (nodeUpdate) => updateNode(node.key, nodeUpdate), updateSchema: (schemaUpdate) => updateNode(node.key, { schema: Object.assign(Object.assign({}, node.schema), schemaUpdate) }), updateUiSchema: (uiSchemaUpdate) => updateNode(node.key, { uiSchema: Object.assign(Object.assign({}, node.uiSchema), uiSchemaUpdate) }), updateUiOptions: this.updateUiOptions })))))));
    }
}
exports.default = react_redux_1.connect(({ tree: { present }, activeNodeKey }) => ({
    node: activeNodeKey && getNode(present, activeNodeKey),
}), (dispatch) => ({
    updateNode: (target, nodeUpdate) => dispatch({
        type: 'TREE_UPDATE_NODE',
        payload: {
            target,
            nodeUpdate,
        },
    }),
}))(Editor);
//# sourceMappingURL=index.js.map