"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const REQUIRED_FIELD_SYMBOL = '*';
function Label(props) {
    const { label, required, id } = props;
    if (!label) {
        // See #312: Ensure compatibility with old versions of React.
        return react_1.default.createElement("div", null);
    }
    return (react_1.default.createElement("label", { className: "control-label", htmlFor: id },
        label,
        required && react_1.default.createElement("span", { className: "required" }, REQUIRED_FIELD_SYMBOL)));
}
function DefaultTemplate(props) {
    const { id, classNames, label, children, errors, help, description, hidden, required, displayLabel } = props;
    if (hidden) {
        return children;
    }
    return (react_1.default.createElement("div", { className: classNames },
        displayLabel && react_1.default.createElement(Label, { label: label, required: required, id: id }),
        displayLabel && description ? description : null,
        children,
        errors,
        help));
}
exports.DefaultTemplate = DefaultTemplate;
function DefaultObjectFieldTemplate(props) {
    const { TitleField, DescriptionField } = props;
    return (react_1.default.createElement("fieldset", null,
        (props.uiSchema['ui:title'] || props.title) && (react_1.default.createElement(TitleField, { id: `${props.idSchema.$id}__title`, title: props.title || props.uiSchema['ui:title'], required: props.required, formContext: props.formContext })),
        props.description && (react_1.default.createElement(DescriptionField, { id: `${props.idSchema.$id}__description`, description: props.description, formContext: props.formContext })),
        props.properties.map((prop) => prop.content)));
}
exports.DefaultObjectFieldTemplate = DefaultObjectFieldTemplate;
//# sourceMappingURL=Template.js.map