"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const antd_1 = require("antd");
const InlineEditor_1 = require("../InlineEditor");
const antd_2 = require("antd");
const Menu_1 = require("./Menu");
class TreeNodeTitle extends react_1.PureComponent {
    render() {
        const { node, removeNode, updateNodeName, searchValue } = this.props;
        const { name, key } = node;
        const isLeaf = node.isLeaf;
        const isRoot = node.name === node.key;
        const isArray = node.schema.type === 'array';
        const indexBefore = node.name.toLowerCase().indexOf(searchValue);
        const indexAfter = indexBefore + searchValue.length;
        return (react_1.default.createElement("span", { style: { width: '100%', display: 'block' } },
            searchValue && indexBefore >= 0 ? (react_1.default.createElement(InlineEditor_1.default, { value: node.name, onChange: (name) => updateNodeName(key, name) },
                name.slice(0, indexBefore),
                react_1.default.createElement("span", { style: { color: '#f50' } }, name.slice(indexBefore, indexAfter)),
                name.slice(indexAfter))) : (react_1.default.createElement(InlineEditor_1.default, { value: node.name, onChange: (name) => updateNodeName(key, name) }, name)),
            react_1.default.createElement("span", { className: "pull-right" },
                !(isLeaf || isArray) ? (react_1.default.createElement("span", { className: "form-builder-add-item-menu", onClick: (e) => e.stopPropagation() },
                    react_1.default.createElement(antd_2.Dropdown, { placement: "bottomLeft", trigger: ['click'], overlay: react_1.default.createElement(Menu_1.default, { node: node }) },
                        react_1.default.createElement(antd_1.Icon, { type: "plus-circle-o" })))) : null,
                !isRoot ? (react_1.default.createElement("span", { className: "tree-node-delete", onClick: (e) => e.stopPropagation() },
                    react_1.default.createElement(antd_1.Popconfirm, { placement: "rightTop", title: `Delete "${key}"?`, onConfirm: () => removeNode(key), okText: "Yes", cancelText: "No" },
                        react_1.default.createElement(antd_1.Icon, { type: "close-circle" })))) : null)));
    }
}
exports.default = react_redux_1.connect(null, (dispatch) => ({
    removeNode: (key) => dispatch({
        type: 'TREE_REMOVE_NODE',
        payload: key,
    }),
    updateNodeName: (key, name) => dispatch({
        type: 'TREE_UPDATE_NODE',
        payload: { target: key, nodeUpdate: { name } },
    }),
}))(TreeNodeTitle);
//# sourceMappingURL=TreeNodeTitle.js.map