"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const antd_1 = require("antd");
const FormList = ({ data, onSelect }) => {
    const items = react_1.useMemo(() => {
        return data.map(d => (react_1.default.createElement(antd_1.List.Item, { key: d.id, onClick: () => onSelect(d) }, d.name)));
    }, [data]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { style: { position: 'relative', right: 0 } },
            react_1.default.createElement(antd_1.Button, { onClick: () => onSelect(null), type: "primary", icon: "plus" })),
        react_1.default.createElement(antd_1.List, { bordered: true }, items)));
};
exports.default = FormList;
//# sourceMappingURL=formList.js.map