"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const prop_types_1 = require("prop-types");
const utils_1 = require("./utils");
function BooleanField(props) {
    const { schema, name, uiSchema, idSchema, formData, registry = utils_1.getDefaultRegistry(), required, disabled, readonly, autofocus, onChange, rawErrors, } = props;
    const { title } = schema;
    const { widgets, formContext } = registry;
    const _a = utils_1.getUiOptions(uiSchema), { widget = 'checkbox' } = _a, options = __rest(_a, ["widget"]);
    const Widget = utils_1.getWidget(schema, widget, widgets);
    const enumOptions = utils_1.optionsList({
        enum: [true, false],
        enumNames: schema.enumNames || ['yes', 'no'],
    });
    return (react_1.default.createElement(Widget, { options: Object.assign(Object.assign({}, options), { enumOptions }), schema: schema, id: idSchema && idSchema.$id, onChange: onChange, label: title === undefined ? name : title, value: formData, required: required, disabled: disabled, readonly: readonly, registry: registry, formContext: formContext, autofocus: autofocus, rawErrors: rawErrors }));
}
if (process.env.NODE_ENV !== 'production') {
    BooleanField.propTypes = {
        schema: prop_types_1.default.object.isRequired,
        uiSchema: prop_types_1.default.object,
        idSchema: prop_types_1.default.object,
        onChange: prop_types_1.default.func.isRequired,
        formData: prop_types_1.default.bool,
        required: prop_types_1.default.bool,
        disabled: prop_types_1.default.bool,
        readonly: prop_types_1.default.bool,
        autofocus: prop_types_1.default.bool,
        registry: prop_types_1.default.shape({
            widgets: prop_types_1.default.objectOf(prop_types_1.default.oneOfType([prop_types_1.default.func, prop_types_1.default.object])).isRequired,
            fields: prop_types_1.default.objectOf(prop_types_1.default.func).isRequired,
            definitions: prop_types_1.default.object.isRequired,
            formContext: prop_types_1.default.object.isRequired,
        }),
        rawErrors: prop_types_1.default.arrayOf(prop_types_1.default.string),
    };
}
BooleanField.defaultProps = {
    uiSchema: {},
    disabled: false,
    readonly: false,
    autofocus: false,
};
exports.default = BooleanField;
//# sourceMappingURL=BooleanField.js.map