"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const prop_types_1 = require("prop-types");
const utils_1 = require("./utils");
function StringField(props) {
    const { schema, name, uiSchema, idSchema, formData, required, disabled, readonly, autofocus, onChange, onBlur, onFocus, registry = utils_1.getDefaultRegistry(), rawErrors, } = props;
    const { title, format } = schema;
    const { widgets, formContext } = registry;
    const enumOptions = utils_1.isSelect(schema) && utils_1.optionsList(schema);
    const defaultWidget = format || (enumOptions ? 'select' : 'text');
    const _a = utils_1.getUiOptions(uiSchema), { widget = defaultWidget, placeholder = '' } = _a, options = __rest(_a, ["widget", "placeholder"]);
    const Widget = utils_1.getWidget(schema, widget, widgets);
    return (react_1.default.createElement(Widget, { options: Object.assign(Object.assign({}, options), { enumOptions }), schema: schema, id: idSchema && idSchema.$id, label: title === undefined ? name : title, value: formData, onChange: onChange, onBlur: onBlur, onFocus: onFocus, required: required, disabled: disabled, readonly: readonly, formContext: formContext, autofocus: autofocus, registry: registry, placeholder: placeholder, rawErrors: rawErrors }));
}
if (process.env.NODE_ENV !== 'production') {
    StringField.propTypes = {
        schema: prop_types_1.default.object.isRequired,
        uiSchema: prop_types_1.default.object.isRequired,
        idSchema: prop_types_1.default.object,
        onChange: prop_types_1.default.func.isRequired,
        onBlur: prop_types_1.default.func,
        onFocus: prop_types_1.default.func,
        formData: prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.number]),
        registry: prop_types_1.default.shape({
            widgets: prop_types_1.default.objectOf(prop_types_1.default.oneOfType([prop_types_1.default.func, prop_types_1.default.object])).isRequired,
            fields: prop_types_1.default.objectOf(prop_types_1.default.func).isRequired,
            definitions: prop_types_1.default.object.isRequired,
            formContext: prop_types_1.default.object.isRequired,
        }),
        formContext: prop_types_1.default.object.isRequired,
        required: prop_types_1.default.bool,
        disabled: prop_types_1.default.bool,
        readonly: prop_types_1.default.bool,
        autofocus: prop_types_1.default.bool,
        rawErrors: prop_types_1.default.arrayOf(prop_types_1.default.string),
    };
}
StringField.defaultProps = {
    uiSchema: {},
    disabled: false,
    readonly: false,
    autofocus: false,
};
exports.default = StringField;
//# sourceMappingURL=StringField.js.map