"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const antd_1 = require("antd");
const ArrayField_1 = require("./ArrayField");
const BooleanField_1 = require("./BooleanField");
const StringField_1 = require("./StringField");
const SchemaField_1 = require("./SchemaField");
const utils_1 = require("react-jsonschema-form/lib/utils");
__export(require("react-jsonschema-form/lib/utils"));
function Error(msg) {
    return () => react_1.default.createElement(antd_1.Alert, { message: msg, type: "error", showIcon: true });
}
function getWidget(...args) {
    try {
        return utils_1.getWidget(...args);
    }
    catch (e) {
        return Error(e.toString());
    }
}
exports.getWidget = getWidget;
function TitleField(props) {
    const { id, title, required } = props;
    return (react_1.default.createElement("legend", { id: id },
        title,
        required ? '*' : null));
}
function getDefaultRegistry() {
    const fields = Object.assign(Object.assign({}, require('react-jsonschema-form/lib/components/fields').default), { ArrayField: ArrayField_1.default,
        StringField: StringField_1.default,
        BooleanField: BooleanField_1.default,
        TitleField,
        SchemaField: SchemaField_1.default });
    return {
        fields,
        widgets: require('react-jsonschema-form/lib/components/widgets').default,
        definitions: {},
        formContext: {},
    };
}
exports.getDefaultRegistry = getDefaultRegistry;
//# sourceMappingURL=utils.js.map