"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const redux_1 = require("redux");
const reducers_1 = require("./reducers");
const redux_persist_1 = require("redux-persist");
const config_1 = require("./config");
const storage_1 = require("redux-persist/lib/storage");
// const storage = require('redux-persist/lib/storage');
const hardSet_1 = require("redux-persist/lib/stateReconciler/hardSet");
// const hardSet = require('redux-persist/lib/stateReconciler/hardSet').default;
var persistConfig = {
    key: 'react-jsonschema-formbuilder',
    storage: storage_1.default,
    stateReconciler: hardSet_1.default,
    throttle: 15,
};
var { schema2tree } = require('./core');
// var form = {
//   schema: {
//     title: 'A registration form',
//     description: 'A simple form example.',
//     type: 'object',
//     required: ['firstName', 'lastName'],
//     properties: {
//       firstName: {
//         type: 'string',
//         title: 'First name',
//       },
//       lastName: {
//         type: 'string',
//         title: 'Last name',
//       },
//       age: {
//         type: 'integer',
//         title: 'Age',
//         description: '(earthian year)',
//       },
//       bio: {
//         type: 'string',
//         title: 'Bio',
//       },
//       password: {
//         type: 'string',
//         title: 'Password',
//         minLength: 3,
//       },
//       telephone: {
//         type: 'string',
//         title: 'Telephone',
//         minLength: 10,
//       },
//     },
//   },
//   uiSchema: {
//     firstName: {
//       classNames: '',
//       'ui:emptyValue': '',
//     },
//     age: {
//       'ui:widget': 'updown',
//     },
//     bio: {
//       'ui:widget': 'textarea',
//     },
//     password: {
//       'ui:widget': 'password',
//       'ui:help': 'Hint: Make it strong!',
//     },
//     date: {
//       'ui:widget': 'alt-datetime',
//     },
//     telephone: {
//       'ui:options': {
//         inputType: 'tel',
//       },
//     },
//   },
// };
const form = { schema: config_1.schema, uiSchema: config_1.uiSchema };
var initTree = schema2tree('root', form.schema, form.uiSchema);
var persistedReducer = redux_persist_1.persistReducer(persistConfig, reducers_1.default);
var store = redux_1.createStore(persistedReducer, {
    tree: {
        past: [],
        present: initTree,
        future: [],
    },
});
exports.store = store;
var persistor = redux_persist_1.persistStore(store);
exports.persistor = persistor;
exports.default = { store, persistor };
//# sourceMappingURL=store.js.map