"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const react_redux_1 = require("react-redux");
const ofm_jsonschema_form_1 = require("@ofm/ofm-jsonschema-form");
class FormView extends react_1.default.Component {
    render() {
        if (!this.props.schema) {
            return null;
        }
        const { schema, uiSchema, formData, setFormData, liveValidate } = this.props;
        console.log('uiSchema: ', uiSchema);
        return (react_1.default.createElement(ofm_jsonschema_form_1.default, { key: Math.random(), schema: schema, uiSchema: uiSchema, formData: formData, onChange: setFormData }));
    }
}
exports.default = react_redux_1.connect(({ tree: { present: [{ name, schema, uiSchema }], }, formData, settings: { isLiveValidate }, }) => ({
    name,
    schema,
    uiSchema,
    formData,
    liveValidate: isLiveValidate,
}), (dispatch) => ({
    setFormData: ({ formData }) => dispatch({
        type: 'FORM_DATA_SET',
        payload: formData,
    }),
}))(FormView);
//# sourceMappingURL=FormView.js.map